PROGRAM AUTOMATA(INPUT,OUTPUT);
CONST PC=10;
    AR=11;
    XR=12;
    YR=13;
    GFX=-224;
    GCS=-221;
    GCL=-215;
    CIR=-203;
    RCT=-209;
    LIN=-212;
    SPX=-245;
    GPX=-251;
    PXY=-257;
    STI=-37;
    RTI=-34;
	BLACK=0;
	RED=2;
	GREEN=5;
	BLUE=6;
VAR I,A,B,C,SEED: INTEGER;
ROW,NROW: ARRAY [0..199] OF INTEGER;
CODE:ARRAY [0..9] OF INTEGER;
COLORS:ARRAY [0..3] OF INTEGER;
DECODE:ARRAY [0..6] OF INTEGER;


FUNCTION READTIME: INTEGER;
VAR T1:INTEGER;
    BEGIN
        CALL(RTI);
		T1:=(REGS[XR]*256) DIV 60;
        READTIME:= REGS[AR] DIV 60 + T1;     
    END;
    
    
PROCEDURE SETTIME(H,M,S:INTEGER);
    BEGIN
        REGS[AR]:=H;
        REGS[XR]:=M;
        REGS[YR]:=S;
        CALL(STI);
    END;


PROCEDURE GRAPHICS;
    BEGIN
        REGS[0]:=0;
        CALL(GFX);
    END;
	
PROCEDURE PIXELXY(X,Y: INTEGER);
	BEGIN
		REGS[0]:=X;
		REGS[1]:=Y;
		CALL(PXY);
	END;	


PROCEDURE SETPIXEL(C: INTEGER);
    BEGIN
        REGS[AR]:=C;
        CALL(SPX);
    END;
	
PROCEDURE GCOLORS(FG,BG,FILL: INTEGER);
	BEGIN
		REGS[AR]:=FG;
		REGS[YR]:=BG;
		REGS[XR]:=FILL;
		CALL(GCL);
	END;
	
PROCEDURE RECT(X,Y,W,H,FILL: INTEGER);
	BEGIN
		REGS[PC]:=FILL;
		REGS[0]:=X;
		REGS[1]:=Y;
		REGS[2]:=W;
		REGS[3]:=H;
		REGS[4]:=0;
		CALL(RCT);
	END;	
	
PROCEDURE GETROW(H,I:INTEGER);
	VAR D,E,N,Q:INTEGER;
	BEGIN
		N:=0;
		D:=H;
		E:=I;
		PIXELXY(H,I);
		WHILE N<200 DO BEGIN
			ROW[N]:=GETPX(0);
			N:=N+1;
		END;
	END;
	
PROCEDURE PUTROW(X,Y:INTEGER);
	VAR X2,Y2,N,C:INTEGER;
	BEGIN
		N:=0;
		X2:=X;
		Y2:=Y;
		PIXELXY(X,Y);
		WHILE N<200 DO BEGIN
			C:=NROW[N];
			SETPIXEL(C);
			N:=N+1;
		END;
	END;	
	
PROCEDURE NEXTROW;
VAR AL,AC,AR,N,CDX,CL:INTEGER;
	BEGIN
		AL:=0;
		AC:=DECODE[ROW[0]];
		AR:=DECODE[ROW[1]];
		CL:=CODE[AL+AC+AR];
		CL:=COLORS[CL];
		NROW[0]:=CL;
		N:=2;
		WHILE N<199 DO BEGIN
			AL:=AC;
			AC:=AR;
			AR:=DECODE[ROW[N]];		
			CL:=CODE[AL+AC+AR];		
			NROW[N-1]:=COLORS[CL];
			N:=N+1;
		END;
		AL:=AC;
		AC:=DECODE[ROW[199]];
		AR:=0;
		CL:=CODE[AL+AC+AR];
		CL:=COLORS[CL];
		NROW[199]:=CL;		
	END;

BEGIN
	COLORS[0]:=BLACK;
	COLORS[1]:=RED;
	COLORS[2]:=GREEN;
	COLORS[3]:=BLUE;
	DECODE[0]:=0;
	DECODE[1]:=0;
	DECODE[2]:=1;
	DECODE[3]:=1;
	DECODE[4]:=1;
	DECODE[5]:=2;
	DECODE[6]:=3;
	CODE[0]:=1;
	CODE[1]:=0;	
	CODE[2]:=3;
	CODE[3]:=1;		
	CODE[4]:=1;
	CODE[5]:=0;	
	CODE[6]:=2;
	CODE[7]:=3;	
	CODE[8]:=3;
	CODE[9]:=2;		
	SEED:=125;
	GOTOXY(0,0);
	WRITELN('4 STATE CELLULAR AUTOMATA DEMO');
    GOTOXY(0,5);
    WRITELN('PRESS ENTER TO START PLOT');
    READ(I);
    GOTOXY(0,5);
    WRITELN('                         ');
    GRAPHICS;
	GCOLORS(0,0,0);	
	CALL(GCS);
	GCOLORS(7,0,0);
	RECT(59,49,202,163,0);
    SETTIME(0,0,0);	
    A:=0;
    C:=0;
	B:=0;
    WHILE B < 200 DO BEGIN
       NROW[B]:=COLORS[0];
       B:=B+1;
     END;
	NROW[99]:=COLORS[(SEED&192) DIV 64];
	NROW[100]:=COLORS[(SEED&48) DIV 16];
	NROW[101]:=COLORS[(SEED&12) DIV 4];
	NROW[102]:=COLORS[SEED&3];
	A:=50;
	B:=60;
	PUTROW(60,50);
	GETROW(60,50);
	WHILE A < 210 DO BEGIN
		NEXTROW;
		PUTROW(60,A+1);
		GETROW(60,A+1);		
		A:=A+1;
	END;
	GOTOXY(0,28);
	WRITELN(READTIME,' SECONDS');
    READLN(A);
 END.
